



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Python编码介绍——encode和decode</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Python编码介绍——encode和decode</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 20:12:03 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<p>在 python 源代码文件中，<strong>如果你有用到非ASCII字符，则需要在文件头部进行字符编码的声明</strong>，声明如下：</p>
<div>
<ol><li><strong># code</strong><strong>:</strong><strong>&nbsp;UTF</strong><strong>-</strong><strong>8</strong></li></ol>
</div>
<p>因为python 只检查 #、coding 和编码字符串，所以你可能回见到下面的声明方式，这是有些人为了美观等原因才这样写的：</p>
<div>
<ol><li>#-*-&nbsp;coding:&nbsp;UTF-8&nbsp;-*-</li></ol>
</div>
<p><strong><br />常见编码介绍：</strong></p>
</div>
<blockquote><div>
<ul><li><strong>GB2312编码：适用于汉字处理、汉字通信等系统之间的信息交换</strong></li>
<li><strong>GBK编码：是汉字编码标准之一，是在 GB2312-80 标准基础上的内码扩展规范，使用了双字节编码</strong></li>
<li><strong>ASCII编码：是对英语字符和二进制之间的关系做的统一规定</strong></li>
<li><strong>Unicode编码：这是一种世界上所有字符的编码。当然了它没有规定的存储方式。</strong></li>
<li><strong>UTF-8编码：是 Unicode Transformation Format - 8 bit 的缩写，&nbsp;<strong>UTF-8 是 Unicode 的一种实现方式</strong>。它是可变长的编码方式，可以使用 1~4 个字节表示一个字符，可根据不同的符号而变化字节长度。</strong></li></ul>
</div></blockquote>
<div>
<p><strong>编码转换：</strong></p>
<p>Python内部的字符串一般都是 Unicode编码。<strong>代码中字符串的默认编码与代码文件本身的编码是一致的。</strong>所以要做一些编码转换通常是要以Unicode作为中间编码进行转换的，即先将其他编码的字符串解码（decode）成 Unicode，再从 Unicode编码（encode）成另一种编码。</p>
</div>
<blockquote><div>
<ul><li><strong>decode&nbsp;</strong>的作用是将其他编码的字符串转换成&nbsp;Unicode&nbsp;编码，eg&nbsp;name.decode(&ldquo;GB2312&rdquo;)，表示将GB2312编码的字符串name转换成Unicode编码</li>
<li><strong>encode&nbsp;</strong>的作用是将Unicode编码转换成其他编码的字符串，eg&nbsp;name.encode(&rdquo;GB2312&ldquo;)，表示将GB2312编码的字符串name转换成GB2312编码</li></ul>
</div></blockquote>
<div>
<p>所以在进行编码转换的时候必须先知道 name 是那种编码，然后 decode 成 Unicode 编码，最后载 encode 成需要编码的编码。当然了，如果 name 已经就是 Unicode 编码了，那么就不需要进行 decode 进行解码转换了，直接用 encode 就可以编码成你所需要的编码。<strong>值得注意的是：对 Unicode 进行编码和对 str 进行编码都是错误的。<br /></strong><br />具体的说就是：如果在UTF-8文件中，则这个字符串就是 UTF-8编码的。它的编码取决于当前的文本编码。当然了，GB2312文本的编码就是GB2312。<strong>要在同一个文本中进行两种编码的输出等操作就必须进行编码的转换</strong>，先用decode将文本原来的编码转换成Unicode，再用encode将编码转换成需要转换成的编码。</p>
<p>eg：<br />由于内置函数 open() 打开文件时，read() 读取的是 str，读取后需要使用正确的编码格式进行 decode()。write() 写入时，如果参数是 Unicode，则需要使用你希望写入的编码进行 encode()，如果是其他编码格式的 str，则需要先用该 str 的编码进行 decode()，转成 Unicode 后再使用写入的编码进行 encode()。如果直接将 Unicode 作为参数传入 write() ，python 将先使用源代码文件声明的字符编码进行编码然后写入。</p>
<div>
<ol><li># coding:&nbsp;UTF-8</li>
<li>fp1&nbsp;=&nbsp;open('test.txt',&nbsp;'r')</li>
<li>info1&nbsp;=&nbsp;fp1.read()</li>
<li># 已知是 GBK 编码，解码成 Unicode</li>
<li>tmp&nbsp;=&nbsp;info1.decode('GBK')</li>
<li>fp2&nbsp;=&nbsp;open('test.txt',&nbsp;'w')</li>
<li># 编码成 UTF-8 编码的 str</li>
<li>info2&nbsp;=&nbsp;tmp.encode('UTF-8')</li>
<li>fp2.write(info2)</li>
<li>fp2.close()</li></ol>
</div>
<p><strong>获取编码的方式：<br /></strong>判断是 s&nbsp;字符串否为Unicode，如果是返回True，不是返回False ：</p>
<div>
<ol><li>isinstance(s,&nbsp;unicode)</li></ol>
</div>
<p>下面代码可以获取系统默认编码：</p>
<div>
<ol><li>#!/usr/bin/env python</li>
<li>#coding=utf-8</li>
<li>import&nbsp;sys</li>
<li>print&nbsp;sys.getdefaultencoding()</li></ol>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rqln5e8o.html">Cesium简介以及离线部署运行</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z14yv9.html">linux-关机出现Telling INIT to go to single user mode&period;无法关机</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwn703q.html">Piwik延迟加载脚本</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kxdw5q.html">Ubuntu下修改system&period;img 解包system&period;img、打包system&period;img</a>
		</li>
						<li><a href="https://www.batexi.com/a/4952o5z9.html">shell读取文件每一行的方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/390zmzoq.html">ios之申请后台延时执行和做一个假后台的方法&lpar;系统进入长时间后台后&comma;再进入前台部分功能不能实现&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/m961m748.html">转：PCL&plus;VS2010环境配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1jo559.html">&lbrack;转&rsqb;谈谈select&comma; iocp&comma; epoll&comma;kqueue及各种网络I&sol;O复用机制</a>
		</li>
						<li><a href="https://www.batexi.com/a/96omgdn9.html">XP下，文件夹添加右键命令行</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1kerj9.html">1030&period; Travel Plan &lpar;30&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p7y2j8.html">IOS开发－OC学习－常用功能代码片段整理</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yr1rz8.html">【原创】自己动手实现JDK动态代理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkvo108.html">ES6的Map如何遍历</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyox739.html">使用syslog服务器存储cp防火墙日志配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r27v49.html">面试HashMap之追命5连问</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwz2ej9.html">django项目添加utf-8编码支持中文</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2yjw2q.html">html5（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jwxvjq.html">导出SharePoint2013用户及权限</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkodg38.html">Android 演示 ViewPager</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4p23mjq.html">PHP 与 UTF-8</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8eym20m9.html">Quartz简单实例</a>
			</li>
						<li><a href="https://www.batexi.com/a/96p3grv8.html">Django ORM操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mej7goq.html">css3 div垂直居中</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m2xw38.html">Python统计栏目页面数量</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdprpd9.html">loadrunner时间损耗-analysis中忽略</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eymv3m9.html">linux下串口通信与管理</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj14x09.html">第七十一，CSS颜色与度量单位</a>
			</li>
						<li><a href="https://www.batexi.com/a/96p3exv8.html">Apple pay的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/96p3v3j8.html">《JS权威指南学习总结--6&period;6属性getter和setter》</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1e4oxq.html">转-CSS优先级（权重）解析</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
